#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_LotteryChipCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_LotteryChipCFG> M_LotteryChipCFG::msSingleton(nullptr);

int M_LotteryChipCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_LotteryChipCFGData* M_LotteryChipCFG::GetData(int Recharge)
{
	auto it = mMapData.find(Recharge);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_LotteryChipCFGData>& M_LotteryChipCFG::GetMapData()
{
	return mMapData;
}

void M_LotteryChipCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_LotteryChipCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_LotteryChipCFGData data;
		data.mRecharge = element->IntAttribute("Recharge");
		data.mRechargeUp = element->IntAttribute("RechargeUp");
		data.mRetChipRate = element->IntAttribute("RetChipRate");
		data.mQuickDeduction = element->IntAttribute("QuickDeduction");
		if (mMapData.find(data.mRecharge) != mMapData.end())std::cout <<"data refind:" << data.mRecharge << std::endl;
		assert(mMapData.find(data.mRecharge) == mMapData.end());
		mMapData.insert(std::make_pair(data.mRecharge, data));
		element = element->NextSiblingElement();
	}
}

void M_LotteryChipCFG::Load()
{
	Load("../Config/M_LotteryChipCFG.xml");
}

M_LotteryChipCFG* M_LotteryChipCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_LotteryChipCFG());
	}
	return msSingleton.get();
}
